module 'data.record' {
   constructor: '=>'/2.

   syntax: infix '=>'.

   syntax: '=>' < ':'.

   /** {} = Record.
    *  Returns an empty record.
    */

   {} =
      'kernel':record_new(X) >>
      module [X] {
         {}.

         {[]}.

         {A . B} :-
            (
               {A},
               {B}
            ).

         {A, B} :-
            (
               {A},
               {B}
            ).

         {Key => Value} :-
            {Key} = Value.

         {Key} = kernel:record_get(X, Key).

         keys(List) :-
            'kernel':record_keys(X, List).

         iter(F) :-
            module F0 [F] {
               do(Key) :-
                  F:do(Key, {Key}).
            },
            'data.list':iter(keys, F0).

         list(List) :-
            module F {
               do(Key) = (Key => {Key}).
            },
            'data.list':iter(keys, F, List).

         copy = 'data.record':({ list }).

         pretty = '\'data.record\':'({ list }).
      }.

   /** { Initial_contents } = Record.
    *  Returns an empty record.
    */

   {Initial_contents} =
      (Record = 'data.record':{}) >>
      (Record:{Initial_contents}) >>
      Record
}
