module io.std {
   read(C) :-
      kernel:stdio_read(C).

   read_line(Line) :-
      String = data.list:accumulate() {
         get(C) :-
            read(C),
            C match (
               '\n'
            ->
               fail
            ;
               'end_of_file'
            ->
               throw('end_of_file')
            ;
               _
            ->
               true
            ).
      },
      Line = data.string:atom(String).

   read_term(C) :-
      kernel:stdio_read_term(C).

   read_term(C, Options) :-
      kernel:stdio_read_term(C, Options).

   write(C) :-
      kernel:stdio_write(C).

   endline :-
      kernel:stdio_endline.

   flush :-
      kernel:stdio_flush.

   format(Format, Args) :-
      kernel:stdio_format(Format, Args).

   print(Term) :-
      kernel:stdio_print(Term).

   print_endline(Term) :-
      kernel:stdio_print_endline(Term).

   close.
}
